#include "global.h"

void clear_menus()
{
	memset(&menus, 0, sizeof(menus));
}

//if opened=2 it means leave it as it was
int add_menu(char *name,int x_1, int x_2, int y_1, int y_2, void *display_func, void *mouseover_func, void *click_func, void *keypress_func, int opened)
{
	int i;
	int cur_menu;

	for(i=0;i<menus_no;i++)
	if(!strcmp(menus[i].name,name))
	break;


	if(i==menus_no)
		{
			cur_menu=menus_no;
			menus_no++;
		}
	else
		{
			cur_menu=i;
		}

	menus[cur_menu].x_1=x_1;
	menus[cur_menu].x_2=x_2;
	menus[cur_menu].y_1=y_1;
	menus[cur_menu].y_2=y_2;


	menus[cur_menu].display_func=display_func;
	menus[cur_menu].mouseover_func=mouseover_func;
	menus[cur_menu].click_func=click_func;
	menus[cur_menu].keypress_func=keypress_func;
	if(opened!=2)menus[cur_menu].opened=opened;

	strcpy(menus[cur_menu].name,name);



	return cur_menu;
}


int mouse_over_menus(int mouse_x, int mouse_y)
{
	int i;

	for(i=menus_no-1;i>=0;i--)
	if(mouse_x>=menus[i].x_1 && mouse_x<=menus[i].x_2 && mouse_y>=menus[i].y_1 && mouse_y<=menus[i].y_2)
	if(menus[i].opened)
	if(menus[i].mouseover_func!=NULL)
		{
			menus[i].mouseover_func(mouse_x,mouse_y);
			return 1;
		}

	return 0;
}

int click_menus(int left_b, int right_b, int mouse_x, int mouse_y)
{
	int i;

	//for(i=0;i<menus_no;i++)
	for(i=menus_no-1;i>=0;i--)
	if(mouse_x>=menus[i].x_1 && mouse_x<=menus[i].x_2 && mouse_y>=menus[i].y_1 && mouse_y<=menus[i].y_2)
	if(menus[i].opened)
	if(menus[i].click_func!=NULL)
		{
			menus[i].click_func(left_b,right_b,mouse_x,mouse_y);
			return 1;
		}

	return 0;

}

void display_menus()
{
	int i;

	for(i=0;i<menus_no;i++)
	if(menus[i].opened)
	if(menus[i].display_func!=NULL)
		{
			menus[i].display_func();
		}

}

int process_keyboard_menus(Uint8 key)
{
	int i;

	for(i=menus_no-1;i>=0;i--)
	if(menus[i].opened)
	if(menus[i].keypress_func!=NULL)
		{
			menus[i].keypress_func(key);
			return 1;
		}

	return 0;
}



