#include "global.h"
#include <time.h>

//format:
// 0: dd:mmm:yyyy hh:mm:ss
// 2: mmm:dd:yyyy hh:mm:ss
// 2: hh:mm:ss dd:mmm:yyyy
// 3: hh:mm:ss mmm:dd:yyyy
void format_date(time_t time_stamp, char *str,int format)
{
	int i;
	//char date_str[30];
	char *date_str;

	//strcpy(date_str,(char*)ctime(&time_stamp));
	date_str=(char*)ctime(&time_stamp);

	if(format==0 || format==1)
	{
		if(format==0)
			{
				for(i=0;i<3;i++)
				str[3+i]=date_str[4+i];

				for(i=0;i<2;i++)
				str[i]=date_str[8+i];

				str[2]=' ';

			}
		else
			{
				for(i=0;i<3;i++)
				str[i]=date_str[4+i];

				for(i=0;i<2;i++)
				str[4+i]=date_str[8+i];

				str[3]=' ';

			}

		//h/m/s
		for(i=0;i<8;i++)
		str[13+i]=date_str[11+i];

		//year
		for(i=0;i<4;i++)
		str[7+i]=date_str[20+i];
		str[6]=' ';
		str[11]=',';
		str[12]=' ';

		str[21]=0;

		return;
	}

	if(format==2 || format==3)
	{
		for(i=0;i<8;i++)
		str[i]=date_str[11+i];

		str[8]=',';
		str[9]=' ';

		if(format==2)
			{
				for(i=0;i<3;i++)
				str[13+i]=date_str[4+i];

				for(i=0;i<2;i++)
				str[10+i]=date_str[8+i];

				str[12]=' ';

			}
		else
			{
				for(i=0;i<3;i++)
				str[10+i]=date_str[4+i];

				for(i=0;i<2;i++)
				str[14+i]=date_str[8+i];

				str[13]=' ';

			}

		//year
		for(i=0;i<4;i++)
		str[17+i]=date_str[20+i];

		str[16]=' ';
		str[21]=0;

		return;
	}
}

void format_number(unsigned long long int number, char *str, char delimiter)
{
	char temp_str[30];
	char temp_str_2[30];
	int len;
	int new_len;
	int delimiters_no;
	int tmp_counter=0;
	int i,j;
	unsigned long long int result;
	int reminder;

	//if(number>(unsigned long long int)0xffffffffff)
	//set_error("Number too big...", "Fuck");

	//sprintf sucks at printing long longs, so we are going to make our own routine to do that
	i=0;
	result=number;
	while(1)
		{
			reminder=result%10;
			temp_str_2[i]=reminder+48;
			result/=10;
			i++;
			if(!result)
				{
					temp_str_2[i]=0;
					break;
				}
		}
	//reverse the string..
	len=strlen(temp_str_2);
	j=len-1;
	for(i=0;i<len;i++)
		{
			temp_str[i]=temp_str_2[j];
			j--;
		}
	temp_str[i]=0;

	if(len<=3)
		{
			strcpy(str,temp_str);
			return;
		}

	delimiters_no=(len/3)-1;

	if(len%3)delimiters_no++;

	new_len=len+delimiters_no;

	i=new_len-1;
	j=len-1;

	while(1)
		{
			str[i]=temp_str[j];
			tmp_counter++;

			if(!(tmp_counter%3))
				{
					i--;
					str[i]=delimiter;

				}

			if(!j)break;

			j--;
			i--;
		}

	str[new_len]=0;

}

void go_to_configh_path()
{

#ifdef WINDOWS
	SHGetFolderPath(NULL, CSIDL_PERSONAL|CSIDL_FLAG_CREATE, NULL, 0, config_path);
#else
	strcpy(config_path,getenv("HOME"));
#endif

	strcat(config_path,"/.my_commander/");
	if(chdir(config_path))//error
#ifndef WINDOWS
		mkdir(config_path, (S_IRWXU|S_IRWXG|S_IRWXO));
#else
		mkdir(config_path);
#endif
	chdir(config_path);
}

char cur_dir_str[256];

void log_message(char * message)
{
	FILE *f = NULL;

	//save the current dir
	getcwd(cur_dir_str, 256);

	f = fopen ("log.txt", "a");
	if(!f)return;

  	fwrite (message, strlen(message), 1, f);
  	fwrite("\n",1, 1, f);
  	fclose(f);

  	chdir(cur_dir_str);
}

void save_settings()
{
	FILE *f = NULL;

	go_to_configh_path();
  	f=fopen("last.cfg","wb");
  	if(!f)return;//blah, whatever

	last_config.window_x_size=window_width;
	last_config.window_y_size=window_height;
	last_config.left_sort_type=panels[0].sort_type;
	last_config.right_sort_type=panels[1].sort_type;
	last_config.show_hidden=show_hidden;
	last_config.date_format=date_format;
	last_config.collums_per_panel=collums_per_panel;
	last_config.kb_size=kb_size;
	last_config.decimal_separator=decimal_separator;


	strcpy(last_config.left_path,panels[0].dir_path);
	strcpy(last_config.right_path,panels[1].dir_path);
	strcpy(last_config.default_editor,default_editor);
	strcpy(last_config.default_viewer,default_viewer);
	strcpy(last_config.hex_viewer,hex_viewer);

	//bookmarks
	memcpy(last_config.bookmarks,bookmarks,sizeof(bookmarks));
	last_config.last_bookmark=last_bookmark;

	fwrite(&last_config,sizeof(config),1,f);
	fclose(f);
}

void load_settings()
{
	FILE *f = NULL;

	//save the current dir
	getcwd(cur_dir_str, 256);

	go_to_configh_path();
  	f=fopen("last.cfg","rb");
  	if(!f)
  		{
  			chdir(cur_dir_str);
			strcpy(panels[0].dir_path,cur_dir_str);
			strcpy(panels[1].dir_path,cur_dir_str);
			panels[0].needs_reread=1;
			panels[1].needs_reread=1;
  			return;//blah, whatever
		}

	fread(&last_config,sizeof(config),1,f);
	fclose(f);

	window_width=last_config.window_x_size;
	window_height=last_config.window_y_size;
	show_hidden=last_config.show_hidden;
	date_format=last_config.date_format;
	kb_size=last_config.kb_size;
	decimal_separator=last_config.decimal_separator;
	collums_per_panel=last_config.collums_per_panel;
	if(collums_per_panel<1)collums_per_panel=4;

	panels[0].sort_type=last_config.left_sort_type;
	panels[1].sort_type=last_config.right_sort_type;
	strcpy(panels[0].dir_path,last_config.left_path);
	strcpy(panels[1].dir_path,last_config.right_path);
	strcpy(default_editor,last_config.default_editor);
	strcpy(default_viewer,last_config.default_viewer);
	strcpy(hex_viewer,last_config.hex_viewer);

	panels[0].needs_reread=1;
	panels[1].needs_reread=1;

	//bookmarks
	memcpy(bookmarks,last_config.bookmarks,sizeof(bookmarks));
	last_bookmark=last_config.last_bookmark;




	chdir(cur_dir_str);
}











